/**
 * The contents of this file are subject to the OpenMRS Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://license.openmrs.org
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * Copyright (C) OpenMRS, LLC.  All Rights Reserved.
 */
package org.openmrs.logic.op;

/**
 * Marker for all transform operator.
 */
public interface TransformOperator extends Operator {
	
	public static final TransformOperator LAST = new Last();
	
	public static final TransformOperator FIRST = new First();
	
	public static final TransformOperator DISTINCT = new Distinct();
	
	public static final TransformOperator EXISTS = new Exists();
	
	public static final TransformOperator NOT_EXISTS = new NotExists();
	
	public static final TransformOperator COUNT = new Count();
	
	public static final TransformOperator AVERAGE = new Average();
	
}
